# Handles dealing with slideshows
# 
# We use make_resourceful to create most of the
# RESTful actions of the controller. We use a custom
# new action because it behaves a little different,
# but otherwise the actions are generated by
# make_resourceful.
class ShowsController < ApplicationController
  in_place_edit_for :show, :title
  
  helper :lyrics
  
  make_resourceful do
    # These are the only actions we need for now
    actions :show, :edit, :destroy
    
    # The slideshow needs to use the S5 layout
    response_for(:show) { render :layout => false }
    # We want to avoid the index URL
    response_for(:destroy) do
      set_default_flash :notice, "The show was deleted."
      set_default_redirect home_path
    end
  end
  
  # Avoid loading shows if we don't use them
  def index; redirect_to home_path; end
  
  # This behaves a little special
  #
  # See SongsController#new
  def new
    @show = current_model.create(:title => 'Untitled')
    redirect_to edit_show_path(@show)
  end
  
  # Assigns new positions to all the songs in
  # the show.
  #
  # This should be called from an Ajax request.
  def reorder
    current_model.find(params[:id]).order! params[:songs_list]
    render :nothing => true
  end
  
  protected
    # Make everything hang off the current user
    #
    # See SongsController#current_model
    def current_model
      current_user.shows
    end
end
